﻿@using System.IO
@using System.Text
@using ElectronNET.API
@using Microsoft.Extensions.Localization
@using OTaskForce.Singletons

@inject IJSRuntime _jsRuntime
@inject IStringLocalizer<ProjectPropertiesEditor> _localizer
@inject ProjectsOperator _projectsOperator

<section class="position-absolute m-0 p-0" style="top: 0; bottom: 0; left: 0; right: 0;">
    <textarea id="task-description-textarea"></textarea>
    
    <button @onclick="async () => await OnSubmitAsync()" type="button" class="btn btn-lg btn-primary rounded-circle position-fixed shadow-lg" style="bottom: 20px; right: 20px; width: 50px; height: 50px; z-index: 1000;">
        <i class="fas fa-save"></i>
    </button>
</section>

<!--suppress CssUnusedSymbol -->
<style>
    .trumbowyg {
        position: absolute;
        top: 0; bottom: 0;
        left: 0; right: 0;
        overflow-y: auto;
    }
</style>

@code {
    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        var taskDescription = await File.ReadAllTextAsync(_projectsOperator.CurrentProjectControl.TaskDescriptionFullPath, Encoding.UTF8);
        
        await _jsRuntime.InvokeVoidAsync("input_set_value", "#task-description-textarea", taskDescription);
        await _jsRuntime.InvokeVoidAsync("add_rich_text_edit", "#task-description-textarea");
        
        await base.OnAfterRenderAsync(firstRender);
    }

    private async Task OnSubmitAsync()
    {
        var newTaskDescription = await _jsRuntime.InvokeAsync<string>("input_get_value", "#task-description-textarea");

        if (string.IsNullOrWhiteSpace(newTaskDescription))
        {
            Electron.Dialog.ShowErrorBox(_localizer["Помилка збереження"], _localizer["Текст умов завдання не може бути пустим!"]);
            return;
        }
        
        await File.WriteAllTextAsync(_projectsOperator.CurrentProjectControl.TaskDescriptionFullPath, newTaskDescription, Encoding.UTF8);
    }
}